﻿--if not AceLibrary then return end

local brokerPlugins = {}
local broker = LibStub("LibDataBroker-1.1")

local AceOO = AceLibrary("AceOO-2.0")
local FuBarPlugin = AceOO.Mixin {
	"SetIcon",
	"SetText",
	"GetAceOptionsDataTable",
	"UpdateDisplay",
	"UpdateText",
}

function FuBarPlugin.OnEmbedInitialize(FuBarPlugin, self)
	ChatFrame1:AddMessage("hat")
--	brokerPlugins[self] = broker:NewDataObject(self:ToString())
end


function FuBarPlugin:GetAceOptionsDataTable()
	return {}
end

function FuBarPlugin:SetIcon(self, path)
	if brokerPlugins[self] then brokerPlugins[self].icon = path end
end

function FuBarPlugin:UpdateDisplay()
end
function FuBarPlugin:UpdateText()
end

local function activate(self, oldLib, oldDeactivate)
	FuBarPlugin = self

	FuBarPlugin.activate(self, oldLib, oldDeactivate)

	if oldDeactivate then
		oldDeactivate(oldLib)
	end
end

local MAJOR_VERSION = "FuBarPlugin-2.0"
local MINOR_VERSION = "$Revision: 999999 $"
AceLibrary:Register(FuBarPlugin, MAJOR_VERSION, MINOR_VERSION, activate)

--[[
FuBar = {}
FuBar.version = "2.0"
FuBar.db = {}
FuBar.db.profile = {}

local broker = LibStub("LibDataBroker-1.1")
local brokerPlugins = {}
local GetTitle = function(self) return self.title or self.name end

function FuBar:RegisterPlugin(plugin)
	if AceLibrary then
		local fub = AceLibrary("FuBarPlugin-2.0")
		if fub then
			fub.GetAceOptionsDataTable = function() return {} end
		end
	end
		
	local name = plugin:ToString()
	if not brokerPlugins[name] then
		local brokerPlugin = broker:NewDataObject(name)
		
		local origSetIcon = plugin.SetIcon
		local origSetText = plugin.SetText
								
		plugin.SetIcon = function(self, path) origSetIcon(self, path) if brokerPlugins[self] then brokerPlugins[self].icon = self.iconFrame:GetTexture() end end
		plugin.SetText = function(self, text) origSetText(self, text) if brokerPlugins[self] then brokerPlugins[self].text = text end end
		
		brokerPlugin.text = name
		brokerPlugin.icon = plugin:SetIcon(plugin.icon or plugin.hasIcon)

		brokerPlugin.OnMenuRequest = plugin.brokerPlugin
		
		brokerPlugin.OnClick = function(frame, button)
			if button == "RightButton" then 
				frame.GetTitle = GetTitle
				frame.OnMenuRequest = plugin.OnMenuRequest
				FuBar:OpenMenu(frame, button) 
			end
		end
		
		brokerPlugin.OnEnter = function(frame)
			frame.GetTitle = GetTitle			
			if plugin.blizzardTooltip then
				local anchor
				if frame:GetTop() > GetScreenHeight() / 2 then
					local x = frame:GetCenter()
					if x < GetScreenWidth() / 2 then
						anchor = "ANCHOR_BOTTOMRIGHT"
					else
						anchor = "ANCHOR_BOTTOMLEFT"
					end
				else
					local x = frame:GetCenter()
					if x < GetScreenWidth() / 2 then
						anchor = "ANCHOR_TOPLEFT"
					else
						anchor = "ANCHOR_TOPRIGHT"
					end
				end
				GameTooltip:SetOwner(frame, anchor)
				if type(plugin.OnTooltipUpdate) == "function" and not plugin:IsDisabled() then
					plugin:OnTooltipUpdate()
				end
				GameTooltip:Show()			
			else
				local tablet = AceLibrary:HasInstance("Tablet-2.0") and AceLibrary("Tablet-2.0")
				local Dewdrop = AceLibrary:HasInstance("Dewdrop-2.0") and AceLibrary("Dewdrop-2.0")
				tablet:Register(frame,
					'children', function()
						tablet:SetTitle(frame:GetTitle() or name)
						if type(plugin.OnTooltipUpdate) == "function" then
							plugin:OnTooltipUpdate()
						end
					end,
					'point', function(frame)
						if frame:GetTop() > GetScreenHeight() / 2 then
							local x = frame:GetCenter()
							if x < GetScreenWidth() / 3 then
								return "TOPLEFT", "BOTTOMLEFT"
							elseif x < GetScreenWidth() * 2 / 3 then
								return "TOP", "BOTTOM"
							else
								return "TOPRIGHT", "BOTTOMRIGHT"
							end
						else
							local x = frame:GetCenter()
							if x < GetScreenWidth() / 3 then
								return "BOTTOMLEFT", "TOPLEFT"
							elseif x < GetScreenWidth() * 2 / 3 then
								return "BOTTOM", "TOP"
							else
								return "BOTTOMRIGHT", "TOPRIGHT"
							end
						end
					end,
					'clickable', plugin.clickableTooltip
				)	
				tablet:Open(frame)
			end
		end
		brokerPlugin.OnLeave = function(frame)
			if plugin.blizzardTooltip then
				GameTooltip:Hide()
			end
		end
		
		brokerPlugins[plugin] = brokerPlugin
	end
end

function FuBar:OpenMenu(frame, button)
	local Dewdrop = AceLibrary:HasInstance("Dewdrop-2.0") and AceLibrary("Dewdrop-2.0")
	
	if not Dewdrop:IsRegistered(frame) then
		if type(frame.OnMenuRequest) == "table" and (not frame.OnMenuRequest.handler or frame.OnMenuRequest.handler == frame) and frame.OnMenuRequest.type == "group" then
			Dewdrop:InjectAceOptionsTable(frame, frame.OnMenuRequest)
		end
		Dewdrop:Register(frame,
			'children', type(frame.OnMenuRequest) == "table" and frame.OnMenuRequest or function(level, value, valueN_1, valueN_2, valueN_3, valueN_4)
				if level == 1 then
					Dewdrop:AddLine(
						'text', frame:GetTitle(),
						'isTitle', true
					)
					if frame.OnMenuRequest then
						frame:OnMenuRequest(level, value, false, valueN_1, valueN_2, valueN_3, valueN_4)
					end
				end
			end,
			'point', function(frame)
				local x, y = frame:GetCenter()
				local leftRight
				if x < GetScreenWidth() / 2 then
					leftRight = "LEFT"
				else
					leftRight = "RIGHT"
				end
				if y < GetScreenHeight() / 2 then
					return "BOTTOM" .. leftRight, "TOP" .. leftRight
				else
					return "TOP" .. leftRight, "BOTTOM" .. leftRight
				end
			end,
			'dontHook', true
		)
	end
	Dewdrop:Open(frame)
end

-- Fake stuff, dirty hacks
function FuBar:ShowPlugin(plugin)
	local brokerPlugin = brokerPlugins[plugin]
	brokerPlugin.icon = plugin:SetIcon(plugin.icon or plugin.hasIcon)
end

function FuBar:IsChangingProfile()
end

local fakePanel = {}
function fakePanel:AddPlugin()

end
function FuBar:GetPanel()
	return fakePanel
end

function FuBar:GetNumPanels()
	return 0
end

]]